"use strict";
var core_1 = require("./core");
var util_1 = require("./util");
var LIFECYCLE_KEY = '$$Lifecycle';
function Lifecycle(target, life, _) {
    var lifecycles = target[LIFECYCLE_KEY] = target[LIFECYCLE_KEY] || util_1.createMap();
    lifecycles[life] = true;
}
exports.Lifecycle = Lifecycle;
core_1.Component.register(LIFECYCLE_KEY, function (proto, instance, options) {
    var lifecycles = proto[LIFECYCLE_KEY];
    for (var lifecycle in lifecycles) {
        // lifecycles may be on proto/methods
        var handler = proto[lifecycle] || options.methods[lifecycle];
        delete proto[lifecycle];
        delete options.methods[lifecycle];
        options[lifecycle] = handler;
    }
});
