"use strict";
var core_1 = require("./core");
var WATCH_PROP = '$$Watch';
function Watch(func, option) {
    return function (target, key) {
        var watchedProps = target[WATCH_PROP] = target[WATCH_PROP] || {};
        if (!option) {
            watchedProps[key] = func;
            return;
        }
        option.handler = func;
        watchedProps[key] = option;
    };
}
exports.Watch = Watch;
core_1.Component.register(WATCH_PROP, function (target, instance, optionsToWrite) {
    var watchedProps = target[WATCH_PROP];
    optionsToWrite.watch = watchedProps;
});
